; Galaksija 8k-54k Emulator wit RAZE.DLL & MIDAS11.DLL
; PureBasic v5.40 LTS Demo code
ExamineDesktops()
Global dt_bit=DesktopDepth(0)/8, dt_w=DesktopWidth(0), dt_h=DesktopHeight(0)
If dt_bit<>4
  MessageRequester("Sorry","The emulator works only on"+#LFCR$+"32 bit desktops !",0) : End
EndIf
Enumeration
  #AF
  #BC
  #DE
  #HL
  #IX
  #IY
  #PC
  #SP
  #AF2
  #BC2
  #DE2
  #HL2
  #IFF1
  #IFF2
  #IR
  #IM
  #IRQV
  #IRQL
  #HALT
  #Z80_MAP_DIRECT=0  ; Reads/writes are done directly
  #Z80_MAP_HANDLED=1 ;Reads/writes use callback
  #GTP_BLOCK_STANDARD=0
  #GTP_BLOCK_TURBO=1
  #GTP_BLOCK_NAME=16
  #MIDAS_MODE_NONE = 0
  #MIDAS_MODE_MONO = 1
  #MIDAS_MODE_STEREO = 2
  #MIDAS_MODE_8BIT = 4
  #MIDAS_MODE_16BIT = 8     
  #MIDAS_LOOP_NO = 0
  #MIDAS_LOOP_YES=1  
EndEnumeration
Structure dos ; 8268 byte
  AF.l
  BC.l
  DE.l
  HL.l
  IX.l
  IY.l
  PC.l
  SP.l
  AF2.l
  BC2.l
  DE2.l
  HL2.l
  IFF.l
  IFF1.l
  IFF2.l
  IM.l
  I.l
  IRQVec.l
  R.l
EndStructure
Structure win ; 8244 byte
  AF.w
  BC.w
  DE.w
  HL.w
  IX.w
  IY.w
  PC.w
  SP.w
  AF2.w
  BC2.w
  DE2.w
  HL2.w
  IM.c
  I.c
  R.c
  unk.c[25]
EndStructure

Structure gmap
  code.i[54]
EndStructure

Structure inv
  v.c[2048]
EndStructure

Structure short
  uw.u
EndStructure

Structure Pix
  Pix.l
EndStructure

PrototypeC.i z0()
PrototypeC.i z1(pp.i)
PrototypeC.i z2(pr.i, pv.w)
PrototypeC.i z3(ps1.w, pe1.w,pa1.i)
PrototypeC.i z4(ps2.w, pe2.w,pm.i,pa2.i)
Prototype.i h0()
Prototype.i h1(hp1.i)
Prototype.i h2(hph.i,hpr.u)
Prototype.i h3(hm1.i,hf1.i,hs1.i)
Prototype.i h4(hp2.i,hp3.i,hb1.i,hm2.i)

Global z80.l, hma.l=1, lstart.w, lend.w, ext.l=2, mmu.q, from.b, fram.b, pnum.l, pname.s, reloc.w, num.c
Global Dim sbuff.a(44100)
Global Dim mem.c(65536)
Global Dim inout.c(65536)
Global tstate.l, sst.b=1, sblv=128, shdl.l, *bfmem=@sbuff(), mutex.l, thend.l, *rtop.short=@mem($2a6a)
Global *rom1=@mem(), *rom2=@mem($1000), *kb_io=@mem($2000),*g_scr=@mem($2800)
Global *rom3=@mem($e000), *mon=@mem($f800), *kb.gmap=?KBMAP, *cgen.inv=?CHRGEN
Global *kbuf=@mem($2bb6), *buffer.String=@*kbuf    ; galksija basic/input buffer (string from .c's)
pat$="Tape (*.gtp)|*.gtp|GAL Snapshot (*.gal)|*.gal|Raze snapshot (*.grz)|*.grz"
ext1$=".gtp.gal.grz" : wTitle.s="Galaksija Minus   " : sWidth=320 
Global *bstart.short=@mem($2c36), *bend.short=@mem($2c38) ; Basic start/end (.w from 2*.c)

Procedure sbfill(*nj)
  Shared hma_bufferfill.h4,sblv, thend
  Protected mua.a, sbcn.l
  Repeat
    While sbcn<255
      LockMutex(mutex) : mua=sblv : UnlockMutex(mutex)
      If mua=$44
        PokeQ(*bfmem+sbcn,$ffffffffffffffff) : sbcn+8
      ElseIf mua=4
        PokeQ(*bfmem+sbcn,$0101010101010101) : sbcn+8
      Else
        PokeQ(*bfmem+sbcn,$8080808080808080) : sbcn+8
      EndIf
      Delay(1);For i=1 To 1500: Next i
    Wend
    hma_bufferfill(shdl,*bfmem,256,#True)
    sbcn=0
  Until thend
EndProcedure

ProcedureC.c inproc(port.u)
  ProcedureReturn inout(port)
EndProcedure

ProcedureC outproc(port.u,out.c)
  inout(port)=out
  If (port&255=255) And IsFile(8)
    If out<>13
      WriteCharacter(8,out) ; (TODO : gfx char convert)
    Else
      WriteStringN(8,"",#PB_Ascii)
    EndIf
  EndIf
EndProcedure

ProcedureC Latch_out(adr.u,dat.c)
  Shared z80_end_emu.z0
  num=dat
  Select adr
    Case $2038 ; tape out
      sblv=num&$44 
    Case $207f ; video latch
      z80_end_emu()
  EndSelect
EndProcedure

ProcedureC.c Latch_in(adr.u)
  Select adr
    Case $2000 ; tape in
    Case $2001 To $2035 ; keyboard
      ExamineKeyboard()
      If KeyboardPushed(*kb\code[adr&255]) : ProcedureReturn 254
      ElseIf adr=$201d And KeyboardPushed(#PB_Key_Back) : ProcedureReturn 254 ;LEFT <- (same as left)
      ElseIf adr=$2035 And KeyboardPushed(#PB_Key_LeftShift) : ProcedureReturn 254 ;Left_SHIFT
      EndIf
  EndSelect
  ProcedureReturn 255
EndProcedure

Procedure Calc(z.q)
  Shared from, fram
  For i=0 To 15
    from+((z&1)*2) : z>>1
  Next i
  fram=62-from
EndProcedure

Procedure SizeWin()  ;window is resized
  ww.l=WindowWidth(0) : wh.l=ww/1.513
  If wh>dt_h
    wh=dt_h : ww=wh*1.513
  EndIf
  ResizeWindow(0,#PB_Ignore,#PB_Ignore,ww,wh)
  ResizeGadget(0, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(1, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(2, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(3, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(4, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(5, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(6, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(7, ww-75, WindowHeight(0)-47, #PB_Ignore, #PB_Ignore)
  ResizeGadget(8, ww-60, #PB_Ignore, #PB_Ignore, #PB_Ignore)
EndProcedure

Procedure Paste()
  text$=Trim(LCase(GetClipboardText())) : basic_l=*bend\uw-*bstart\uw
  If text$
    line_num.u=0
    If basic_l
      i=*bstart\uw+2
      While i<(*bend\uw-2)
        If mem(i)=13 : line_num=mem(i+1)+(mem(i+2)*256) : i+3
        Else : i+1
        EndIf
      Wend
    EndIf
    line_num+5
    
  EndIf
EndProcedure

CopyMemory(?ROM_A,*rom1,?ROM_B-?ROM_A) : mmu|%11
CopyMemory(?ROM_B,*rom2,?ROM_C-?ROM_B) : mmu|%1100
;CopyMemory(?ROM_C,*rom1+$e000,?MONITOR-?ROM_C) : mmu|$30000000
If mmu&12 : mmu|$80000000 : EndIf ; Monitor only works if ROM2 present
If mmu&$30000000
  PokeL(*rom1+$3f8,$e000c4e5) : PokeB(*rom1+$37,30) ; patch for ROM2 + ROM3 init & ROM version
ElseIf mmu&12
  PokeL(*rom1+$3f8,$1000c4e5) : PokeB(*rom1+$37,29) ; patch for ROM2 init & ROM version
Else
  PokeL(*rom1+$3f8,$e70c3ee5) : PokeB(*rom1+$37,28) ; patch for ROM1 only init & ROM version
EndIf 
Calc(mmu)
r$="Galaksija "+Str(from)+"K-"+Str(fram)+"K"
If OpenWindow(0, -1, -1, 640, 423, wTitle, #PB_Window_ScreenCentered|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget)
  ButtonGadget(0, 580, 10, 45, 20, "Quit")
  ButtonGadget(1, 580, 40, 45, 20, "NMI")
  ButtonGadget(2, 580, 65, 45, 20, "RESET")
  ButtonGadget(3, 580, 100, 45, 20, "Load")
  ButtonGadget(4, 580, 125, 45, 20, "Save")
  ButtonGadget(5, 580, 160, 45, 20,"Options") : DisableGadget(5,1)
  ButtonGadget(6, 580, 185, 45, 20,"Help")
  ButtonGadget(8, 580, 210, 45, 5,"") : HideGadget(8,1) ; hidden gadget without function
  AddKeyboardShortcut(0, #PB_Shortcut_F1,  #PB_Shortcut_F1)    ; Help (and other keyboard shortcuts)
  AddKeyboardShortcut(0, #PB_Shortcut_F2,  #PB_Shortcut_F2)    ; Save
  AddKeyboardShortcut(0, #PB_Shortcut_F3,  #PB_Shortcut_F3)    ; Load
  AddKeyboardShortcut(0, #PB_Shortcut_F5,  #PB_Shortcut_F5)    ; paste clipboard content
  AddKeyboardShortcut(0, #PB_Shortcut_F9,  #PB_Shortcut_F9)    ; NMI (RST66)
  AddKeyboardShortcut(0, #PB_Shortcut_F10,  #PB_Shortcut_F10)  ; Reset Z80
  AddKeyboardShortcut(0, #PB_Shortcut_F12,  #PB_Shortcut_F12)  ; Options
  CheckBoxGadget(7,565,376,72,20,"Printer ON") 
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(#PB_Ignore) ; autosize this field
    AddStatusBarField(150) ; autosize this field
    AddStatusBarField(50) ; autosize this field
    StatusBarText(0, 0, r$) ; initial config message on leftmost cell
    bar_h=StatusBarHeight(0) : btn_w=GadgetWidth(7)+6
  EndIf
  If InitSprite() And OpenWindowedScreen(WindowID(0), 0, 0, sWidth, 240, 1, btn_w, bar_h) And InitKeyboard() And InitSound()
    SetFrameRate(50) : WindowBounds(0, 320+btn_w, 240+bar_h, #PB_Ignore, #PB_Ignore)
    SetWindowColor(0,0) : SmartWindowRefresh(0, 1)
    If OpenLibrary(z80,"raze.dll") And OpenLibrary(hma,"midas11.dll") ; preparing external DLL-s for fast call
      hma_startup.h0=GetFunction(hma,"_MIDASstartup@0")
      hma_init.h0=GetFunction(hma,"_MIDASinit@0")
      hma_opench.h1=GetFunction(hma,"_MIDASopenChannels@4")
      hma_closech.h0=GetFunction(hma,"_MIDAScloseChannels@0")
      hma_startbgplay.h1=GetFunction(hma,"_MIDASstartBackgroundPlay@4")
      hma_playstream.h3=GetFunction(hma,"_MIDASplayStreamPolling@12")
      hma_setrate.h2=GetFunction(hma,"_MIDASsetStreamRate@8")
      hma_setvol.h2=GetFunction(hma,"_MIDASsetStreamVolume@8")
      hma_bufferstate.h1=GetFunction(hma,"_MIDASgetStreamBytesBuffered@4")
      hma_bufferfill.h4=GetFunction(hma,"_MIDASfeedStreamData@16")
      hma_pause.h1=GetFunction(hma,"_MIDASpauseStream@4")
      hma_resume.h1=GetFunction(hma,"_MIDASresumeStream@4")
      hma_stop.h1=GetFunction(hma,"_MIDASstopStream@4")
      hma_stopbgplay.h0=GetFunction(hma,"_MIDASstopBackgroundPlay@0")
      hma_end.h0=GetFunction(hma,"_MIDASclose@0")
      If hma_startup() And hma_init() ; initialize Galaksija audio
        hma_opench(1) ; this must be here, ( documentation error!)
        hma_startbgplay(0) ; silence without buffer filler
        shdl=hma_playstream(#MIDAS_MODE_MONO,44100,100)
        ;mutex=CreateMutex() ; tape out sound sucks !!!
        ;thread=CreateThread(@sbfill(),128) ; need to fix it (but how?)
      EndIf
      z80_init_memmap.z0=GetFunction(z80,"_z80_init_memmap")
      z80_map_fetch.z3=GetFunction(z80,"_z80_map_fetch")
      z80_add_read.z4=GetFunction(z80,"_z80_add_read")
      z80_add_write.z4=GetFunction(z80,"_z80_add_write")
      z80_set_in.z1=GetFunction(z80,"_z80_set_in")
      z80_set_out.z1=GetFunction(z80,"_z80_set_out")
      z80_end_memmap.z0=GetFunction(z80,"_z80_end_memmap")
      z80_reset.z0=GetFunction(z80,"_z80_reset")
      z80_cause_NMI.z0=GetFunction(z80,"_z80_cause_NMI")
      z80_get_context_size.z0=GetFunction(z80,"_z80_get_context_size")
      z80_get_context.z1=GetFunction(z80,"_z80_get_context")
      z80_set_context.z1=GetFunction(z80,"_z80_set_context")
      z80_get_reg.z1=GetFunction(z80,"_z80_get_reg")
      z80_set_reg.z2=GetFunction(z80,"_z80_set_reg")
      z80_emulate.z1=GetFunction(z80,"_z80_emulate")
      z80_get_cycles.z0=GetFunction(z80,"_z80_get_cycles_elapsed")
      z80_raise_IRQ.z1=GetFunction(z80,"_z80_raise_IRQ")
      z80_lower_IRQ.z0=GetFunction(z80,"_z80_lower_IRQ")
      z80_fetch_callback.z1=GetFunction(z80,"_z80_set_fetch_callback")
      z80_end_emu.z0=GetFunction(z80,"_z80_stop_emulating")
      z80_init_memmap() ; z80 config
      z80_map_fetch(0, $ffff, *rom1)      ; Allow opcodes To be fetched from all ROM/RAM
      z80_add_read(0, $1fff, #Z80_MAP_DIRECT, *rom1)      ; Allow reads from ROM_1
      z80_add_read($2000, $27ff, #Z80_MAP_HANDLED, @Latch_in())      ; Set callback for Tape/Keyboard read
      z80_add_read($2800, $ffff, #Z80_MAP_DIRECT, *g_scr)            ; Allow reads from rest of RAM/ROM
      z80_add_write($2000, $27ff, #Z80_MAP_HANDLED, @Latch_out())    ; Set callback for Tape/Video writes
      If mmu&$80000000 
        CopyMemory(?MONITOR,*rom3+$1800,?KBMAP-?MONITOR)      ; MONITOR ROM copyed to ram
        z80_add_write($2800, $f7ff, #Z80_MAP_DIRECT, *g_scr)  ; allow writes to rest of RAM (48k)
      Else
        z80_map_fetch($f800, $ffff, *mon)      ; Allow opcodes To be fetched from HIGH RAM
        z80_add_write($2800, $ffff, #Z80_MAP_DIRECT, *g_scr) ; allow RAM writes (54k)
      EndIf
      z80_set_in(@inproc())    ; recommended for ROM2/48K (Printer, AY Sound etc.)
      z80_set_out(@outproc())  ; recommended for ROM2/48K (Printer, AY Sound etc.)
      z80_end_memmap()
      z80_reset() ; reset the CPU
      snap_size.l=z80_get_context_size()
      *snap_adr=ReAllocateMemory(*snap_adr,snap_size) ; allocating secondary Z80 workplace for snapshots
      If *snap_adr
        z80_get_context(*snap_adr) ; fill workplace with current Z80 status
      Else
        MessageRequester("Error","Memory allocation failed!",0)
      EndIf
    Else
      MessageRequester("Error", "Can't find Z80 core!", 0)
      End
    EndIf
  Else
    MessageRequester("Error", "Can't open windowed screen!", 0)
    End
  EndIf
  BindEvent(#PB_Event_SizeWindow,@SizeWin()) ; faster treatment of window resizing
  Repeat
    Event = WindowEvent()
    Select Event 
      Case #PB_Event_Gadget ; button clicked
        Select EventGadget()
          Case 0 ; Quit
            Break
          Case 1 ; NMI
            z80_cause_NMI() :
          Case 2 ; Reset
            z80_reset() : StatusBarText(0, 0, r$)
          Case 3 ; Load
            reloc=0 : Gosub Load
          Case 4 ; Save
            lstart=0 : lend=0 : reloc=0 : Gosub Save
          Case 5 ; Options (TODO : Ram/Rom/Sound config)
          Case 6 ; Help (TODO : keyboard/monitor/basic etc. CHM)
          Case 7 ;Printer ON/OFF
            If GetGadgetState(7)
              pname=OpenFileRequester("Print spooler",pname,"Text file (*.txt)|*.txt",0)
              If pname<>"" And OpenFile(8,pname,#PB_File_SharedWrite|#PB_File_Append)
                SetGadgetText(7,"Printer OFF")
              Else
                SetGadgetState(7,#PB_Checkbox_Unchecked) : SetGadgetText(7,"Printer ON")
                MessageRequester("Error","File open error, or"+#LFCR$+"Requester canceled!",0)
              EndIf
            Else
              CloseFile(8) : SetGadgetText(7,"Printer ON")
            EndIf
        EndSelect
        SetActiveGadget(8) 
      Case #PB_Event_Menu ; is shortcat key pressed? (keys are associated with menus)
        Select EventMenu()
          Case  #PB_Shortcut_F1 ; Help
          Case  #PB_Shortcut_F2 ; Save
            lstart=0 : lend=0 : reloc=0 : Gosub Save
          Case  #PB_Shortcut_F3 ; Load
            reloc=0 : Gosub Load
          Case  #PB_Shortcut_F9 ; NMI
            z80_cause_NMI()
          Case  #PB_Shortcut_F10 ; Reset
            z80_reset() : StatusBarText(0, 0, r$)
          Case  #PB_Shortcut_F12 ;Options
          Case #PB_Shortcut_F5   ; Paste Basic/Assembly program from clipboard to Galaksija RAM
            Paste()
        EndSelect
      Case #PB_Event_CloseWindow ; window closed directly (same as Quit)
        Break 
      Case #PB_Event_WindowDrop ; picture dropped on window (TODO)
    EndSelect
    z80_emulate(3072000/1000) ; emulate only ~3072 of ~61440 cycles, to leave time to main event loop
    cyc=z80_get_cycles()
    If cyc<3070 ; 423<T<2144=after IRQ, 61/62T=any raster except every 13th+HBlank+14th/1st in original (258T)
      Debug Hex(z80_get_reg(#IR)|((num!128)&128))+"  -  "+Str((num>>2)&15)+" : "+" T"+Str(cyc)
      z80_emulate(3072000/1000) : Continue ; do not draw screen yet
    Else ; in case of false, random latch writes (T<60 or T>2143 )
      Debug Hex(z80_get_reg(#IR)|((num!128)&128))+"  -  "+Str((num>>2)&15)+" : "+" T"+Str(cyc)
    EndIf
    If Not tstate               ; every 20th loop iteration (~61440 cycles=50Hz) draw galaksija screen
        SetWindowTitle(0,wTitle+Str(1000/(ElapsedMilliseconds()-time))+ " FPS")
        time=ElapsedMilliseconds() : StatusBarText(0, 2, Str((*rtop\uw-*bend\uw)))
      FlipBuffers()           ; synchronizes Window refresh with screen drawing (double buffering)
      ClearScreen(0)          ; clear screen, before interupt checking
      If z80_get_reg(#IFF1)   ; if the interupt is enabled... (RST38 or IM2 is possible !)
        sst=1 : StartDrawing(ScreenOutput()) ; redraw whole screen...
        DBuff      = DrawingBuffer()             ; Get the start address of the screen buffer
        Pitch       = DrawingBufferPitch()       ; Get the length (in byte) took by one horizontal line
        Real=Pitch-(sWidth*dt_bit)+256            ;320 wide reported as 384 ?! Correction to real size
        top_sp = mem($2bb0)*3 : left_sp =(mem($2ba8)-8)*32
        *Line.Pix = DBuff+(Pitch*(top_sp+16))+left_sp
        For j = 0 To 207-top_sp ; 16 row * 13 lines = 208 lines - vertical offset (fine scroll)
          row=$2800+(j/13)*32 : offset=(j%13)*128 ; row adress on screen and line offset in CHRGEN
          For i = 0 To 31 ; columns in 1 row
            bit=mem(row+i) : sByte=*cgen\v[offset+((bit&63)|((bit>>1)&64))] ; get char byte for current line
            For bit=0 To 7 : *Line\Pix = ((sByte>>bit)&1)-1 : *Line+dt_bit : Next ; invert bits to longs directly on surface
          Next : *Line+Real ; set next line adress with horizontal offset
        Next j
        StopDrawing()
      Else
        If sst ; if the interupt is disabled, check keyboard buffer for OLD, SAVE and *S commands
          bff$=ReplaceString(Trim(*buffer\s),"&","$") ; replace galaksija hex notation with PB ones
          If Left(bff$,4)="SAVE"                      ; is that command SAVE from Basic?
            bff$=LTrim(Mid(bff$,5))
            lstart=Val(StringField(bff$,1,",")) : lend=Val(StringField(bff$,2,",")) : reloc=0 ; get eventual parameters
            ext=0 : Gosub Save                                                                ; execute command
            sst=0                                                                             ; SAVE at end performs NMI, so interupt is enabled again
          ElseIf Left(bff$,2)="*S"                                                            ; is that command Save from Monitor?
            bff$=LTrim(Mid(bff$,3))
            lstart=Val(StringField(bff$,1,",")) : lend=Val(StringField(bff$,2,",")) : reloc=Val(StringField(bff$,3,","))
            ext=0 : Gosub Save ; get eventual parameters and  execute command
            sst=0
          ElseIf Left(bff$,3)="OLD" ; is that command Load from Basic?
            reloc=Val(ReplaceString(Mid(bff$,4),"?"," ")) ; ignore verification argument, but get relocation parameter
            Gosub Load
          EndIf
        EndIf
      EndIf
      z80_raise_IRQ(Random(255))
      z80_lower_IRQ() ; signal INT for Z80, to execute RST38 (video drawing)
      tstate=20       ; count next 20 loop iterations before cheking video generation interupt 
    EndIf
    tstate-1 ; step down counter
  ForEver
  
  thend=1 ; signal to sound generation thread to end
  z80_end_emu() : CloseLibrary(z80) ; end z80 emulation and close raze.dll
  ;WaitThread(thread) : FreeMutex(mutex) ; if the thread ends, free his mutex
  hma_end() : CloseLibrary(hma)     ; end sound playback and close midas11.dll
  End
EndIf

Load:
f$=OpenFileRequester("Select Galaksija file to load","",pat$,ext)
If f$ And ReadFile(4,f$)
  flen=Lof(4) : ext=SelectedFilePattern() : bn$=""
  Select ext
    Case 0 ; gtp - multi block load
      bcn.c=0
      While Eof(4)=0
        Select ReadByte(4)
          Case 0,1 ; normal & turbo block
            len.l=ReadLong(4)
            hdr.c=ReadByte(4)
            lstart.w=ReadWord(4)
            lend.w=ReadWord(4)
            ReadData(4,*rom1+lstart+reloc,lend-lstart)
            crc.c=ReadByte(4) : junk.c=ReadByte(4)
            If Loc(4)<flen : bcn+1 : Continue : EndIf
            z80_cause_NMI() : Break 
            ;z80_set_reg(#PC,$317) : Break 
          Case 16 ; name block
            len.l=ReadLong(4) : bn$=RSet(StrU(bcn),2,"0")+". "+Space(len)
            ReadData(4,@bn$+4,len) : StatusBarText(0,1,bn$,#PB_StatusBar_Center)
        EndSelect
      Wend
    Case 1 ; gal snapshot
      If flen=8268 ;dos
        ReadData(4,@dhead.dos,76)
        ReadData(4,*kb_io,8192)
        z80_set_reg(#AF,dhead\AF)
        z80_set_reg(#BC,dhead\BC)
        z80_set_reg(#DE,dhead\DE)
        z80_set_reg(#HL,dhead\HL)
        z80_set_reg(#IX,dhead\IX)
        z80_set_reg(#IY,dhead\IY)
        z80_set_reg(#PC,dhead\PC)
        z80_set_reg(#SP,dhead\SP)
        z80_set_reg(#AF2,dhead\AF2)
        z80_set_reg(#BC2,dhead\BC2)
        z80_set_reg(#DE2,dhead\DE2)
        z80_set_reg(#HL2,dhead\HL2)
        z80_set_reg(#IFF1,#True)
        z80_set_reg(#IFF2,#True)
        z80_set_reg(#IM,1)
        z80_set_reg(#IRQV,255)
        z80_set_reg(#IRQL,0)
        z80_set_reg(#IR,(dhead\I<<8)|dhead\R)
        z80_set_reg(#HALT,#False)
      ElseIf flen=8244 ;win
        ReadData(4,@whead.win,52)
        ReadData(4,*kb_io,8192)
        z80_set_reg(#AF,whead\AF)
        z80_set_reg(#BC,whead\BC)
        z80_set_reg(#DE,whead\DE)
        z80_set_reg(#HL,whead\HL)
        z80_set_reg(#IX,whead\IX)
        z80_set_reg(#IY,whead\IY)
        z80_set_reg(#PC,whead\PC)
        z80_set_reg(#SP,whead\SP)
        z80_set_reg(#AF2,whead\AF2)
        z80_set_reg(#BC2,whead\BC2)
        z80_set_reg(#DE2,whead\DE2)
        z80_set_reg(#HL2,whead\HL2)
        z80_set_reg(#IFF1,#True)
        z80_set_reg(#IFF2,#True)
        z80_set_reg(#IM,1)
        z80_set_reg(#IRQV,255)
        z80_set_reg(#IRQL,0)
        z80_set_reg(#IR,(dhead\I<<8)|dhead\R)
        z80_set_reg(#HALT,#False)
      EndIf
    Case 2 ;grz - raze native snapshot
      If *snap_adr
        ReadData(4,*snap_adr,68)
        ReadData(4,*kb_io,flen-Loc(4)) ; (TODO : memory re-config to be add !
        z80_set_context(*snap_adr)
      Else
        MessageRequester("Error","Not enaugh memory!",0)
      EndIf
  EndSelect
  StatusBarText(0, 0, f$) : StatusBarText(0, 1, bn$)
  CloseFile(4)
EndIf
Return
Save:
f$=SaveFileRequester("Save snapshot As...",f$,pat$,ext)
If *snap_adr And f$
  ext=SelectedFilePattern() :ext2$=Mid(ext1$,(ext*4)+1,4)
  If Right(f$,4)<>ext2$ : f$+ext2$ : EndIf
  Select ext
    Case 2 ; grz
      z80_get_context(*snap_adr)
      If CreateFile(3,f$)
        WriteData(3,*snap_adr,68)
        WriteData(3,*kb_io,(fram+2)*1024)
        CloseFile(3)
        StatusBarText(0, 0, f$)
      Else
        MessageRequester("Error","File not saved!",0)
      EndIf
    Case 1 ; gal
      MessageRequester("Info","Format not supported !"+#LFCR$+"File Not saved!",0)
    Case 0 ; gtp
      tlen.q=FileSize(f$)
      If (tlen=-1 And OpenFile(3,f$)); Or (tlen And OpenFile(3,f$,#PB_File_Append))
        If lstart=0 Or lend=0 : lstart=$2c36 : lend=*bend\uw : EndIf
        lstart+reloc : lend+reloc : len.l=lend-lstart
        crc.c=$A5+(lstart&255)+(lstart>>8)+(lend&255)+(lend>>8)
        WriteByte(3,16) : WriteLong(3,Len(GetFilePart(f$))+1) : WriteString(3,GetFilePart(f$)) : WriteByte(3,0) ; name block
        WriteByte(3,0) : WriteLong(3,len+7) : WriteByte(3,$a5) : WriteWord(3,lstart) : WriteWord(3,lend)        ; data block (standard -)
        For i=(lstart-reloc) To (lend-reloc)-1 : WriteCharacter(3,mem(i)) : crc+mem(i) : Next i
        WriteWord(3,crc!255) : CloseFile(3)
      Else
        MessageRequester("Info","File not saved!",0)
      EndIf
  EndSelect
Else
  MessageRequester("Error","Not enaugh memory!",0)
EndIf
Return
DataSection
  ROM_A:
  IncludeBinary "ROM1.BIN"
  ROM_B:
  IncludeBinary "ROM2.BIN"
  ROM_C:
  IncludeBinary "ROM3.BIN"
  CHRGEN:
  IncludeBinary "CHRGEN.BIN"
  MONITOR:
  IncludeBinary "MONITOR.BIN"
  KBMAP:
  Data.i 0,#PB_Key_A,#PB_Key_B,#PB_Key_C,#PB_Key_D,#PB_Key_E,#PB_Key_F,#PB_Key_G,#PB_Key_H,#PB_Key_I,#PB_Key_J,#PB_Key_K,#PB_Key_L
  Data.i #PB_Key_M,#PB_Key_N,#PB_Key_O,#PB_Key_P,#PB_Key_Q,#PB_Key_R,#PB_Key_S,#PB_Key_T,#PB_Key_U,#PB_Key_V,#PB_Key_W,#PB_Key_X
  Data.i #PB_Key_Y,#PB_Key_Z,#PB_Key_Up,#PB_Key_Down,#PB_Key_Left,#PB_Key_Right,#PB_Key_Space,#PB_Key_0,#PB_Key_1,#PB_Key_2
  Data.i #PB_Key_3,#PB_Key_4,#PB_Key_5,#PB_Key_6,#PB_Key_7,#PB_Key_8,#PB_Key_9,#PB_Key_SemiColon,#PB_Key_Minus,#PB_Key_Comma
  Data.i #PB_Key_Equals,#PB_Key_Period,#PB_Key_Slash,#PB_Key_Return,#PB_Key_Escape,#PB_Key_RightControl,#PB_Key_Delete
  Data.i#PB_Key_PageDown,#PB_Key_RightShift
EndDataSection
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 391
; FirstLine = 382
; Folding = --
; EnableThread
; EnableXP
; UseIcon = Galaxy2.ICO
; Executable = Galaksija.exe
; CPU = 1
; CompileSourceDirectory